
function rgb(r, g, b)
    return ((r*256)+g)*256+b
end

Mechanism=Mechanism or Core.class(Sprite)

function Mechanism:init()
    local w, h=application:getContentWidth(), application:getContentHeight()
    
    self.world=b2.World.new(0, 9.81, true)
    b2.setScale(400)
    
    local edge=self.world:createTerrain(nil, {0, 0, w, 0, w, h, 0, h, 0, 0})
        
    local zero=Bitmap.new("Images/ZeroBrane.png")
    zero:setScale(0.5)
    self.world:createRectangle(zero, {type="static", draggable=false})
    zero:setAnchorPoint(0.5, 0.5)
    zero:setPosition(w/2, 189)
    self:addChild(zero)
    
    local gideros=Bitmap.new("Images/Gideros.png")
    gideros:setScale(0.50)
    self.world:createCircle(gideros, {type="dynamic", draggable=true})
    gideros:setAnchorPoint(0.5, 0.5)
    gideros:setPosition(w/2, 671)
    self:addChild(gideros)
    
    local  gx, gy=gideros:getPosition()
    local zx, zy=zero:getPosition()
    local jdef=b2.createDistanceJointDef(gideros.body, zero.body, gx, gy, zx, zy)
    self.world:createJoint(jdef)
   
    stage:addChild(self)
    
    stage:addEventListener(Event.ENTER_FRAME, function(...) pcall(self.onEnterFrame, ...) end, self)
end

function Mechanism:onEnterFrame()
    self.world:update()
end

application:setBackgroundColor(rgb(255, 207, 156))
application:reset()
Mechanism.new()